// code by jph

// TODO some of this should go to  mesh.hpp !!

// TODO consistency checks:
// * degree of vertex >1, sum degree of vertex even!?
// * function to compute genus


//int meshgl::addVertex(tensor<double> pnt) {
//  int v3f=offsetV3F();
//  tensor<float> col(1,arr.size[0]);  
//  col(v3f+0)=pnt(0);
//  col(v3f+1)=pnt(1);
//  col(v3f+2)=pnt(2);
//  arr<<=col;
//  return arr.size[1]-1;
//}
//
void meshgl::remVertex(int val) { // only references to vertex are deleted
  int bol;  
  for (int c0=0;c0<MESH_MAX;++c0) {
    linked<int> lnk;
    for (int c1=0;c1<ind[c0].size[1];++c1) {
      bol=0;
      for (int c2=0;c2<MESH_COMP[c0];++c2) 
        bol|=ind[c0](c2,c1)==val;
      if (bol)
        lnk.add(c1);
    }
    if (lnk.numel) {
      lnk.add(-1);
      tensor<int> flt=lnk.toTensor();    
      tensor<int> idx(1,ind[c0].size[1]-flt.numel+1);
      int cnt=0;
      int run=0;
      for (int c1=0;c1<ind[c0].size[1];++c1)
        if (c1==flt(run))
          run++;        
        else
          idx(cnt++)=c1;      
      ind[c0]=ind[c0](tensor<int>::index(1,MESH_COMP[c0]),idx);
    }
  }
}

tensor<int> meshgl::references(void) {
  tensor<int> ret(1,0);
  for (int c0=0;c0<MESH_MAX;++c0)
    ret=ret&ind[c0].flatten().unique();
  return ret.unique();
}

// removes vertices that are not indexed
meshgl meshgl::reduce(void) {
  meshgl ret(*this);
  tensor<int> ref=references();
  ret.arr=arr(tensor<int>::index(1,arr.size[0]),ref);  
  tensor<int> idx=tensor<int>::index(1,arr.size[1]);
  for (int c0=0;c0<ref.numel;++c0)
    idx(ref(c0))=c0;
  for (int c0=0;c0<MESH_MAX;++c0)
    for (int c1=0;c1<ret.ind[c0].numel;++c1) 
      ret.ind[c0].data[c1]=idx(ret.ind[c0].data[c1]);  
  return ret;
}

// unites close vertices
meshgl meshgl::collapse(double thr) {
  // TODO sort according to x, since symmetry accross
  meshgl ret(*this);
  tensor<int> idx=tensor<int>::index(1,arr.size[1]);
  tensor<int> cl0=tensor<int>::index(1,3)+offsetV3F();
  tensor<int> cl1(1,1);
  for (int c0=0;c0<arr.size[1]-1;++c0)
    if (idx(c0)==c0) {
      printf(".",c0);
      for (int c1=c0+1;c1<arr.size[1];++c1)
        if ((arr(cl0,cl1+c0)-arr(cl0,cl1+c1)).norm()<thr)
          idx(c1)=c0;
    } else
      printf("x",c0);    
  printf("\n");
  for (int c0=0;c0<MESH_MAX;++c0)
    for (int c1=0;c1<ret.ind[c0].numel;++c1)
      ret.ind[c0].data[c1]=idx(ret.ind[c0].data[c1]);
  return ret;
}

meshgl meshgl::collapse(tensor<int> ref,double thr) {
  meshgl ret(*this);
  tensor<int> idx=tensor<int>::index(1,arr.size[1]);
  tensor<int> cl0=tensor<int>::index(1,3)+offsetV3F();
  tensor<int> cl1(1,1);
  for (int c0=0;c0<ref.numel;++c0)
    for (int c1=0;c1<arr.size[1];++c1)
      if ((arr(cl0,cl1+ref(c0))-arr(cl0,cl1+c1)).norm()<thr)
        idx(c1)=ref(c0);
  for (int c0=0;c0<MESH_MAX;++c0)
    for (int c1=0;c1<ret.ind[c0].numel;++c1)
      ret.ind[c0].data[c1]=idx(ret.ind[c0].data[c1]);
  return ret;
}

meshgl meshgl::mirror(tensor<int> idx) {
  int v3f=offsetV3F();
  meshgl ret(*this);
  ret.arr=arr&arr;
  for (int c0=arr.size[1];c0<ret.arr.size[1];++c0)
    ret.arr(v3f+1,c0)=-ret.arr(v3f+1,c0);
  tensor<int> map=tensor<int>::index(1,arr.size[1])+arr.size[1];
  for (int c0=0;c0<idx.numel;++c0) {
    ret.arr(v3f+1,idx(c0))=0;
    map(idx(c0))=idx(c0);
  }
  for (int c0=0;c0<MESH_MAX;++c0) {
    tensor<int> grb=tensor<int>::index(1,MESH_COMP[c0])*(-1)+MESH_COMP[c0]-1;
    switch (c0) {
      case MESH_QUAD:
        grb.as(grb(3),grb(0),grb(1),grb(2));
        break;
    }
    tensor<int> app=ind[c0](grb,tensor<int>::index(1,ind[c0].size[1]));
    for (int c1=0;c1<app.numel;++c1)
      app.data[c1]=map(app.data[c1]);
    ret.ind[c0]=ind[c0]&app;
  }
  return ret.reduce();
}

#define MESHGL_CUT                                                          \
    dpt=arr(zin,shp).to<double>();                                          \
    mvt=dpt.min_(mnd);                                                      \
    if (mvt*dpt.max_(mxd)<0) { /*need to cut triangle*/                     \
      cnt=0;                                                                \
      for (mnd=0;mnd<3 && !(dpt(mnd%3)<0 && 0<dpt((mnd+1)%3));++mnd)        \
        ;                                                                   \
      assert(mnd<3);                                                        \
      for (int c1=mnd;c1<mnd+3;++c1) {                                      \
        e0= c1   %3;                                                        \
        e1=(c1+1)%3;                                                        \
        if (dpt(e0)*dpt(e1)<0) {                                            \
          mxd=c1;                                                           \
          k0=shp(e0);                                                       \
          k1=shp(e1);                                                       \
          if (hsh.get(k0<<16|k1,val))                                       \
            edg(cnt++)=val;                                                 \
          else {                                                            \
            edg(cnt++)=val=arr.size[1]+ret_arr.numel;                       \
            v0=arr[k0];                                       \
            v1=arr[k1];                                       \
            ret_arr.add(v0+(v0-v1)*(dpt(e0)/(dpt(e1)-dpt(e0))));            \
            hsh.put(k0<<16|k1,val);                                         \
          }                                                                 \
        }                                                                   \
      }                                                                     \
      assert(cnt==2);                                                       \
      ret_edg.add(edg);                                                     \
      ret_tri.add(tensor<int>(1,3).as(shp(mnd),edg(0),edg(1)));             \
      mxd=(mnd+2)%3;                                                        \
      if (dpt(mxd)<0)                                                       \
        ret_tri.add(tensor<int>(1,3).as(shp(mnd),edg(1),shp(mxd)));         \
    } else                                                                  \
      if (mvt<0)                                                            \
        ret_tri.add(shp);

// ! mesh is not reduce()d , i.e. there might be a lot of unreferenced vertices !
// ! edges are not structured !
// ! normals are not updated !
// TODO returned meshgl contains only triangles (no quads) possibly this can be changed for speed up (if all verts are <0)
meshgl meshgl::cut(void) {
  timer* tmr;
  tmr=timer::tic("meshgl::cut1");
  meshgl ret;
  ret.format=format;
  int abv=1;
  for (int c0=offsetV3F()+2;c0<arr.numel&&abv;c0+=arr.size[0])
    abv&=0<arr.data[c0];
  if (abv)
    return ret;
  tmr->toc();
  tmr=timer::tic("meshgl::cut2");
  hash<uint,int> hsh(ind[MESH_TRIA].size[1]/2+ind[MESH_QUAD].size[1]);
  tensor<int> zin=tensor<int>::vector(1).as(offsetV3F()+2);
  tensor<int> edg(1,2);
  tensor<double> dpt;
  int val;
  int cnt;
  uint k0,k1;
  int mnd,mxd;
  int e0,e1;
  linked<tensor<float>> ret_arr;
  linked<tensor<int>>   ret_edg;
  linked<tensor<int>>   ret_tri;
  tensor<int> shp(1,3);
  double mvt;
  tensor<float> v0;
  tensor<float> v1;
  for (int c0=0;c0<ind[MESH_TRIA].numel;c0+=3) {
    shp.data[0]=ind[MESH_TRIA].data[c0+0];
    shp.data[1]=ind[MESH_TRIA].data[c0+1];
    shp.data[2]=ind[MESH_TRIA].data[c0+2];
    MESHGL_CUT
  }
  for (int c0=0;c0<ind[MESH_QUAD].numel;c0+=4) {
    shp.data[0]=ind[MESH_QUAD].data[c0+3];
    shp.data[1]=ind[MESH_QUAD].data[c0+0];
    shp.data[2]=ind[MESH_QUAD].data[c0+1];
    MESHGL_CUT
    shp.data[0]=ind[MESH_QUAD].data[c0+1];
    shp.data[1]=ind[MESH_QUAD].data[c0+2];
    shp.data[2]=ind[MESH_QUAD].data[c0+3];
    MESHGL_CUT
  }
  ret.arr=arr&ret_arr.toTensor(arr.size[0]); // 1 of 17
  ret.ind[MESH_EDGE]=ret_edg.toTensor(2);
  ret.ind[MESH_TRIA]=ret_tri.toTensor(3);
  tmr->toc();
  //printf("%s\n",hsh.toInfo());
  return ret;
}

tensor<double> meshgl::point(int idx) {
  int v3f=offsetV3F();
  tensor<double> ret(1,4);
  ret.data[0]=arr(v3f+0,idx);
  ret.data[1]=arr(v3f+1,idx);
  ret.data[2]=arr(v3f+2,idx);
  ret.data[3]=1;
  return ret;
}

tensor<double> meshgl::vector(int idx) {
  int v3f=offsetV3F();
  tensor<double> ret(1,4);
  ret.data[0]=arr(v3f+0,idx);
  ret.data[1]=arr(v3f+1,idx);
  ret.data[2]=arr(v3f+2,idx);
  return ret;
}

tensor<double> meshgl::normal(int idx) {
  int n3f=offsetN3F();
  tensor<double> ret(1,4);
  ret.data[0]=arr(n3f+0,idx);
  ret.data[1]=arr(n3f+1,idx);
  ret.data[2]=arr(n3f+2,idx);
  return ret;
}

