// code by jph

#ifndef NODE_INCLUDED
#define NODE_INCLUDED

static char NODE_BUFFER[8192];

template<class type>
class node {
public:
  node<type>(void); // ok
  virtual ~node<type>(void); // ok
  node(node<type>* myNode,int numel); // ok
  node(node<type>* myNode,int numel,const type& copy); // ok
  char* toInfo(void); // ok
//----------------------------------------------------------------------
  node<type>* prev;         // points to previous node
  tensor<node<type>*> next; // array of child nodes
  type data;                // content
};

template<class type>
node<type>::node(void) {
  prev=0;
}

template<class type>
node<type>::~node(void) {
}

template<class type>
node<type>::node(node<type>* myNode,int numel) {
  prev=myNode;
  next=tensor<node*>(1,numel);
}

template<class type>
node<type>::node(node<type>* myNode,int numel,const type& copy) {
  prev=myNode;
  next=tensor<node*>(1,numel);
  data=copy; // TODO check function of operator=
}

template<class type>
char* node<type>::toInfo(void) {
  sprintf(NODE_BUFFER,"%p node<%i>(%p,%i:",this,sizeof(type),prev,next.numel);
  for (int c0=0;c0<next.numel;++c0)
    sprintf(&NODE_BUFFER[strlen(NODE_BUFFER)],"%p.",next.data[c0]);
  sprintf(&NODE_BUFFER[strlen(NODE_BUFFER)-1],")");
  return NODE_BUFFER;
}

#endif
